var com = com || {};
com.nature = com.nature || {};

(function ($) {
	$(document).ready(function () {

		if ($.trim($('#fielded-keyword').val()) === '') {
			$('#fielded-search-submit').attr('disabled', 'disabled');
		}

		$('#fielded-search fieldset').on('keyup change blur focus', '#fielded-keyword', function () {
			if ($.trim($('#fielded-keyword').val()) !== '') {
				$('#fielded-search-submit').removeAttr('disabled');
			}
		});

		$('#fielded-search fieldset').keypress(function (e) {
			if (e.which === 13 && $.trim($('#fielded-keyword').val()) === '') {
				e.preventDefault();
			}
		});

		var getLatestResearchFor = function (subjectCode, dateRange) {
			$('#latest-research').append('<div class="loading"></div>');
			$('#latest-research').load('/srep/ajax/latest-research.html', {
				'filter-subjects': subjectCode,
				'filter-date': dateRange
			}, function () {
				latestResearchFilter();
			});
		};

		var getLatestResearchForDate = function (subjectCode, dateRange) {
			getLatestResearchFor(subjectCode, dateRange);
			com.nature.PageManager.track({'action': 'filter_date', 'destination': 'filter_date_' + dateRange});
		};

		var getLatestResearchForSubject = function (subjectCode, dateRange) {
			getLatestResearchFor(subjectCode, dateRange);
			com.nature.PageManager.track({'action': 'filter_subject', 'destination': 'filter_subject_' + subjectCode});
		};

		var latestResearchFilter = function () {
			com.nature.LimitedAuthorsList.init();

			var selectedSubject = $("#filter-subjects option:selected");
			var selectedDate = $("#filter-date option[selected]");
			var selectedSubjectValue = $("#filter-subjects").val();
			var selectedDateValue = $("#filter-date").val();

			// Construct subject popup from select box
			var subjectPopup = $('<ol/>', {
				'id': "filter-subjects-popup"
			});
			var subjectPopupCaller = $('<a/>', {
				'text': (selectedSubject.size() > 0) ? selectedSubject.text(): "All subjects",
				'class': "dropdown"
			});

			var popupList;
			$("#filter-subjects").find("option").each(function (i, option) {
				var popupEntry = $('<li/>', {}).appendTo(subjectPopup);
				var seperator = ($(option).next('option').size() === 0) ? " " : ", ";
				var subjectText = ($(option).prev('option').size() > 0 || $(option).parent('optgroup').size() === 0) ? $(option).text() : $(option).text().substring(4);
				var subjectLink = $('<a/>', {
					'href': '?filter-subjects=' + $(option).val() + '&filter-date=' + selectedDateValue,
					'class': $(option).prop('disabled') ? "disabled" : "",
					'text': subjectText + seperator,
					'click': function (e) {
						if (!$(option).prop('disabled')) {
							getLatestResearchForSubject($(option).val(), selectedDateValue);
							$("#filter-subjects-popup").hide();
						}
						return false;
					}
				});
				if ($(option).parent('optgroup').size() === 0) {
					popupEntry.append(subjectLink);
				} else if ($(option).prev('option').size() === 0) {
					popupList = jQuery('<ol/>', {}).appendTo(popupEntry);
					popupList.before(subjectLink);
				} else {
					var subjectListing = popupEntry.append(subjectLink);
					popupList.append(subjectListing);
				}
			});

			$("#filter-subjects").replaceWith(subjectPopupCaller);
			subjectPopupCaller.after(subjectPopup).click(function (e) {
				$(this).toggleClass("dropdown-active");
				$(conferencePopupCaller).removeClass("dropdown-active");
				$(datePopupCaller).removeClass("dropdown-active");
				$("#filter-subjects-popup").toggle();
				$("#filter-conference-popup").hide();
				$("#filter-date-popup").hide();
				e.stopPropagation();
			});

			//construct date popup from select box
			var datePopup = jQuery('<ol/>', {
				'id': "filter-date-popup"
			});
			var datePopupCaller = $('<a/>', {
				'text': (selectedDate.size() > 0) ? selectedDate.text(): "All dates",
				'class': "dropdown"
			});
			$("#filter-date").children("option").each(function (i, option) {
				var dateLink = $('<a/>', {
					'href': '?filter-subjects=' + selectedSubjectValue + '&filter-date=' + $(option).val(),
					'class': $(option).prop('disabled') ? "disabled" : "",
					'text': $(option).text(),
					'click': function (e) {
						if (!$(option).prop('disabled')) {
							getLatestResearchForDate(selectedSubjectValue, $(option).val());
							$("#filter-date-popup").hide();
						}
						return false;
					}
				});
				var dateListing = $('<li>', {}).append(dateLink);
				datePopup.append(dateListing);
			});
			$("#filter-date").replaceWith(datePopupCaller);
			datePopupCaller.after(datePopup).click(function (e) {
				$(this).toggleClass("dropdown-active");
				$(conferencePopupCaller).removeClass("dropdown-active");
				$(subjectPopupCaller).removeClass("dropdown-active");
				$("#filter-date-popup").toggle();
				$("#filter-conference-popup").hide();
				$("#filter-subjects-popup").hide();
				datePopup.css('left', datePopupCaller.position().left);
				e.stopPropagation();
			});

			// Conference drop down - works diffrently in that it takes you off to a new page/url
			// a very poor temporary solution added for SALT-803
			var conferencePopup = $('<ol/>', {
				'id': "filter-conference-popup"
			});
			var conferencePopupCaller = $('<a/>', {
				'text': "Conference proceedings",
				'class': "dropdown"
			});
			var conferenceLink = jQuery('<a/>', {
				'href': $("#filter-conference").attr('href'),
				'text': $("#filter-conference").text()
			});
			var conferenceListing = $('<li>', {}).append(conferenceLink);
			conferencePopup.append(conferenceListing);

			$("#filter-conference").replaceWith(conferencePopupCaller);
			conferencePopupCaller.after(conferencePopup).click(function (e) {
				$(this).toggleClass("dropdown-active");
				$(datePopupCaller).removeClass("dropdown-active");
				$(subjectPopupCaller).removeClass("dropdown-active");
				$("#filter-conference-popup").toggle();
				$("#filter-date-popup").hide();
				$("#filter-subjects-popup").hide();
				conferencePopup.css('left', conferencePopupCaller.position().left + conferencePopupCaller.width());
				e.stopPropagation();
			});

			$('body').click(function () {
				$(datePopupCaller).removeClass("dropdown-active");
				$(subjectPopupCaller).removeClass("dropdown-active");
				$(conferencePopupCaller).removeClass("dropdown-active");
				$("#filter-subjects-popup").hide();
				$("#filter-date-popup").hide();
				$("#filter-conference-popup").hide();
			});
			$("#filter-subjects-popup, #filter-date-popup, #filter-conference-popup").click(function (e) {
				e.stopPropagation();
			});

			$("#latest-research-filter button").hide();
		};

		latestResearchFilter();
	});
}(jQuery));